utility-ht-0.0.5.1: Various small helper functions for Lists, Maybes, Tuples, Functions

Safe Haskell | Safe-Inferred

Data.Bool.HT

Synopsis

- if' :: Bool -> a -> a -> a
- select :: a -> [(Bool, a)] -> a
- (?:) :: Bool -> (a, a) -> a
- implies :: Bool -> Bool -> Bool

# Documentation

if' :: Bool -> a -> a -> aSource

`if-then-else` as function.

Example:

     if' (even n) "even" $
     if' (isPrime n) "prime" $
     "boring"

select :: a -> [(Bool, a)] -> aSource

From a list of expressions choose the one, whose condition is true.

Example:

     select "boring" $
       (even n, "even") :
       (isPrime n, "prime") :
       []

(?:) :: Bool -> (a, a) -> aSource

Like the `?` operator of the C progamming language. Example: `bool ?: (yes, no)`.

implies :: Bool -> Bool -> Bool Source

Logical operator for implication.

Funnily because of the ordering of `Bool` it holds `implies == (<=)`.